// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItem.hpp"
#include "component/display/IRenderableComponent.hpp"
#include "ui/UIComponent.hpp"

namespace Dawn {
  class UICanvas :
    public SceneComponent,
    public IRenderableComponent
  {
    protected:
      std::shared_ptr<Mesh> mesh;

      virtual void onInit() override;
      virtual void onDispose() override;

    public:
      std::vector<std::shared_ptr<UIComponent>> components;


      std::vector<std::shared_ptr<IRenderPass>> getPasses(
        struct RenderPassContext &ctx
      ) override;
  };
}