// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "ui/UIAlign.hpp"
#include "display/shader/UIShader.hpp"

namespace Dawn {
  class UICanvas;

  class UIComponent {
    protected:
      virtual std::vector<struct UIShaderQuad> getSelfQuads(
        const glm::mat4 transform
      ) = 0;

      virtual std::vector<std::shared_ptr<UIComponent>> getChildren();

      std::vector<struct UIShaderQuad> getQuads(
        const glm::mat4 parent
      );

    public:
      glm::vec2 position;

      friend class UICanvas;
  };
}